# Wiki

Welcome to the InversifyJS wiki!

## Installation and environment support

- [Installation](./installation.md)
- [Environment support and polyfills](./environment.md)
- [Vanilla JavaScript example](./basic_js_example.md)
- [ES5 and ES6 support](./javascript.md)
- [Upgrade guide](./upgrade.md)

## The InversifyJS Features and API

- [Support for classes](./classes_as_id.md)
- [Support for Symbols](./symbols_as_id.md)
- [Container API](./container_api.md)
- [Declaring container modules](./container_modules.md)
- [Container snapshots](./container_snapshots.md)
- [Controlling the scope of the dependencies](./scope.md)
- [Declaring optional dependencies](./optional_dependencies.md)
- [Injecting a constant or dynamic value](./value_injection.md)
- [Injecting a class constructor](./constructor_injection.md)
- [Injecting a Factory](./factory_injection.md)
- [Auto factory](./auto_factory.md)
- [Auto named factory](./auto_named_factory.md)
- [Injecting a Provider (asynchronous Factory)](./provider_injection.md)
- [Activation handler](./activation_handler.md)
- [Deactivation handler](./deactivation_handler.md)
- [Post Construct decorator](./post_construct.md)
- [Middleware](./middleware.md)
- [Multi-injection](./multi_injection.md)
- [Tagged bindings](./tagged_bindings.md)
- [Create your own tag decorators](./custom_tag_decorators.md)
- [Named bindings](./named_bindings.md)
- [Default target](./default_targets.md)
- [Support for hierarchical DI systems](./hierarchical_di.md)
- [Contextual bindings & @targetName](./contextual_bindings.md)
- [Property injection](./property_injection.md)
- [Circular dependencies](./circular_dependencies.md)
- [Inheritance](./inheritance.md)
- [Transitive bindings](./transitive_bindings.md)

## Other documents

- [Why InversifyJS?](./purpose.md)
- [Object-oriented design](./oo_design.md)
- [Good practices](./good_practices.md)
- [Ecosystem](./ecosystem.md)
- [Recipes](./recipes.md)
- [Injecting npm modules](./injecting_npm_modules.md)
- [Architecture overview](./architecture.md)
- [Glossary](./glossary.md)
- [Roadmap](https://github.com/inversify/InversifyJS/milestones)
